<?php

require ("vglib.php");

CheckCookie();

session_start();

	if (!$_GET[id])		//If there was no ID given in the URL,
	{	$action="Add";	//the form becomes an Add form.

		if ($_GET[nt])	//If there's an nt attribute in the URL,
					//that changes which radio box (Musician,
					//Group or Source) is filled.  If none is
					//supplied, the default is Musician.

		{	$nametype=ucwords(strtolower($_GET[nt]));
		}
		else $nametype="Musician"; 
	}

	else 		// If there is an ID, the form becomes 
			// an Edit form.

	{
		if (!$SESSION[error])	//If the user didn't provoke an error
					//on a previous submission of the page, 
					//we connect to the database.
		{

			$handle=ConnectToDb();

			array_walk($_POST,'CleanInput');  

			$spelling_id=$_GET[id];
			$action="Edit";

	//Then we check to see if a name entry of that ID really already exists:
		
			$query_to_issue = "SELECT name, entity_id, abbrev, nametype, namecat, namecomment, temphide, permhide FROM vgNames WHERE spelling_id = $spelling_id";

			$query_result = mysql_query($query_to_issue, $handle)
				or die(mysql_error());


		/* If an entry that ID doesn't exist already, the form becomes an add form, so as not to screw up the sequence of IDs (which is auto-incremented by MySQL).  We also wipe out the $spelling_id variable so the title display doesn't get messed up later on. */

			if (mysql_num_rows($query_result) < 1) 
			{	$action="Add";
				$spelling_id="";
				$nametype="Musician";
			}


		//But if it's still an Edit form, then we do this stuff.

			if (mysql_num_rows($query_result) > 0) 
			{	$name_info = mysql_fetch_array($query_result);

				//We grab the existing details about this entry 
				//from the just-issued database query so as to be 
				//able to have the forms pre-filled with them.

				$name = $name_info['name'];
				$nametype = $name_info['nametype'];
				$namecat = $name_info['namecat'];
				$namecomment=$name_info['namecomment'];
				$abbrev = $name_info['abbrev'];
				$entity_id = $name_info['entity_id'];
				$temphide = $name_info['temphide'];
				$permhide = $name_info['permhide'];
			}
		}
	}

	//Or, if the user did provoke an error on a previous submission
	//of the form, we do this.  

	//The values that the user entered before they last 
	//submitted the page are read back in from the _SESSION 
	//array, to which they were written by the next page's script,
	//so we can refill the forms with what they submitted before.

	if ($_SESSION[error])
	{	
		$nametype=$_SESSION[nametype];

		$name=$_SESSION[name];
		$abbrev=$_SESSION[abbrev];
		$entity_id=$_SESSION[entity_id];
		$namecat=$_SESSION[namecat];
		$namecomment=$_SESSION[namecomment];
		$temphide=$_SESSION[temphide];
		$permhide=$_SESSION[permhide];

		$same_as_name=$_SESSION[same_as_name];

	}
	if ($action=="Add")
	{	$namecat=$_SESSION[namecat];
	}

?>

<html>
<head>
<title><?php 

	if ($action=="Add")
	{	$pagetitle="$action a Musician, Group, Source, or Stream";
	}
	else 
	{	$pagetitle="Edit $nametype #$spelling_id";
	}
	echo $pagetitle;
?>
</title>

<link rel=stylesheet href="css/a.css" type="text/css">

<script language="JavaScript"> 

var clickedonce=new Array();

//* Then we have some JavaScript.  Nothing but JavaScript for a while, no PHP.*//

function Alert(x)
{	window.alert(x);
}

function Fo(where)
{	document.ford.name.focus();
}

function SetEnd (TB)
{
	if (TB.createTextRange)
	{
		var FieldRange = TB.createTextRange();
		FieldRange.moveStart('character', TB.value.length);
		FieldRange.collapse();
		FieldRange.select();
	}
}

function PerformAction(action)
{
	if (action=="restore")
	{
		ford.reset();
		return;
	}
	if (action=="wipe out")
	{
		len=ford.length;
		for (x=0;x<len;x++)
		{	if (ford.elements[x].type=="text" ||
				ford.elements[x].type=="textarea")
			{
				ford.elements[x].value='';
			}
		}
		return;
	}
	if (action=="close")
	{	CloseWindow();
		return;
	}
}

</script></head>
<body onLoad="Fo()">
<center>
<?php 

ListNav();

echo "<h2>$pagetitle</h2>";

?>

<p>

<?php

	if ($_SESSION[error]=="blank forms")
	{	EchoError("Error: Please supply a new name.");
	}

	if ($_SESSION[error]=="name exists")
	{	EchoError("Error: You entered a name which already exists in the database.  If this is intentional, please put a check in the Permit Duplicate Names box and resubmit the form.");
	}
	if ($_SESSION[error]=="entity id must be num")
	{	EchoError("Error: The Entity ID must be a number or blank.");	
	}

	if ($_SESSION[error]=="same entity nonexistent")
	{	EchoError("Error: The entity you said was the same as $name doesn't exist in the database.");
	}

	if ($_SESSION[error]=="supply lower entity id")
	{	EchoError("Error: Please supply a lower Entity ID, lower than the highest one currently in existence.");
	}

	if ($_SESSION[error]=="name not same type")
	{	EchoError("Error: The entity you said was the same as $name exists in the database, but is of a different name type.");
	}

	if ($_SESSION[error]=="already exists as abbrev")
	{	EchoError("Error: The names and abbreviations you enter must not be the same as any existing abbreviation.");
	}
?>

<form method=post action="editname.php" name="ford">

<INPUT TYPE=RADIO NAME="nametype" VALUE="Musician" <?php if ($nametype=="Musician") { echo "checked"; } ?>>Musician &nbsp; 

<INPUT TYPE=RADIO NAME="nametype" VALUE="Group" <?php if ($nametype=="Group") { echo "checked"; } ?>>Group &nbsp; 

<INPUT TYPE=RADIO NAME="nametype" VALUE="Source" <?php if ($nametype=="Source") { echo "checked"; } ?>>Source

<INPUT TYPE=RADIO NAME="nametype" VALUE="Stream" <?php if ($nametype=="Stream") { echo "checked"; } ?>>Stream

<p>
<input type=checkbox name="temphide" value="y" <?php if ($temphide=="y") { echo "checked"; }?>> Temphide
&nbsp;&nbsp;<input type=checkbox name="permhide" value="y" <?php if ($permhide=="y") { echo "checked"; }?>> Permhide
<p>

<?php 	// Hidden inputs, only present when this is an Edit form.
	// This makes it so the database doesn't have to be requeried to
	// get the details when there's an error sending 
	// you back to this page, and it also changes the behavior of
	// the script on the next page a bit.

	if ($action=="Edit")
	{	echo "<input type=\"hidden\" name=\"spelling_id\" value=\"$spelling_id\">\n\n";
	}

?>
<! The input fields.>

<b>New Name</b><br>
<input type="text" name="name" onFocus="SetEnd(this)" size=60 maxlength=255 value="<?php echo $name; ?>">
<P>
<b>Unique Abbreviation</b><br>
<input type="text" name="abbrev" size=20 maxlength=255 value="<?php echo $abbrev; ?>">
<p>
<b>Category</b><br>
<input type="text" name="namecat" size=30 maxlength=255 value="<?php echo $namecat; ?>">
<p>
<b>Comment</b><br>
<textarea type="text" name="namecomment" cols=60 rows=3><?php echo $namecomment; ?></textarea>
<P>
<br>
<input type=checkbox name="permitdups" value="y"> Permit Duplicate Names
<p>
<b>Same As (Name or Abbrev.)</b><br>
<input type="text" name="same_as_name" size=60 maxlength=255 value="<?php echo $same_as_name; ?>">
<p>
<b>Entity ID</b><br>
<input type="text" name="entity_id" size=20 maxlength=255 value="<?php echo $entity_id; ?>">
<p>
<P><input type="submit" name="submit" class="button" value="Submit"></p>

<p>
<br>
<! The handy-dandy JavaScript buttons. >
<table width=80%><tr><td align="right"><input type="button" class="dangerousbutton" onClick="PerformAction('restore')" value="Restore"><p><input type="button" class="dangerousbutton" onClick="PerformAction('wipe out')" value="Clear"></table>

</form>
</body></html>