<?php

require ("vglib.php");

CheckCookie();

$handle=ConnectToDb();

function mysql_field_array( $query )
{	//Returns an array listing the table fields present in a query result.
	$field = mysql_num_fields( $query );

	for ( $i = 0; $i < $field; $i++ )
	{
		$names[] = mysql_field_name( $query, $i );
	}
	return $names;
}

//Here are all the queries which will create the empty tables.

$create_songtagmap_table = "CREATE TABLE `songtagmap` (
  `tagmap_id` int(10) unsigned NOT NULL auto_increment,
  `song_id` int(10) unsigned NOT NULL,
  `tag_id` int(10) unsigned NOT NULL,
  `tagtypenum` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`tagmap_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci  ;";

$create_tags_table = "CREATE TABLE `tags` (
  `tag_id` int(10) unsigned NOT NULL auto_increment,
  `tag_name` varchar(255) collate latin1_general_ci default NULL,
  `whenadded` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`tag_id`),
  UNIQUE KEY `tag_name` (`tag_name`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci  ;";

$create_vgnames_table = "CREATE TABLE `vgnames` (
  `spelling_id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) collate latin1_general_ci NOT NULL,
  `abbrev` varchar(255) collate latin1_general_ci NOT NULL,
  `entity_id` int(10) unsigned NOT NULL,
  `nametype` enum('Musician','Group','Source','Stream') collate latin1_general_ci NOT NULL,
  `namecat` varchar(255) collate latin1_general_ci NOT NULL,
  `namecomment` text collate latin1_general_ci NOT NULL,
  `temphide` enum('n','y') collate latin1_general_ci NOT NULL,
  `permhide` enum('n','y') collate latin1_general_ci NOT NULL,
  `whenadded` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`spelling_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci  ;";

$create_vgnameurls_table = "CREATE TABLE `vgnameurls` (
  `nameurl_id` int(10) unsigned NOT NULL auto_increment,
  `entity_id` int(10) unsigned NOT NULL,
  `spelling_id` int(10) unsigned NOT NULL,
  `nameurl` varchar(255) collate latin1_general_ci NOT NULL,
  `nameurltype` varchar(255) collate latin1_general_ci NOT NULL,
  `nameurlcomment` text collate latin1_general_ci NOT NULL,
  `temphide` enum('n','y') collate latin1_general_ci NOT NULL,
  `permhide` enum('n','y') collate latin1_general_ci NOT NULL,
  `whenadded` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`nameurl_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci  ;";

$create_rolesandsongs_table = "CREATE TABLE `vgrolesandsongs` (
  `generic_id` int(10) unsigned NOT NULL auto_increment,
  `spelling_id` int(10) unsigned NOT NULL,
  `entity_id` int(10) unsigned NOT NULL,
  `song_id` int(10) unsigned NOT NULL,
  `role` enum('source','performer','vocalist','remixer','composer') collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`generic_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci  ;";

$create_songdetails_table = "CREATE TABLE `vgsongdetails` (
  `song_id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) collate latin1_general_ci default NULL,
  `filename` varchar(255) collate latin1_general_ci default NULL,
  `localfolder` text collate latin1_general_ci,
  `filesize` int(10) unsigned default NULL,
  `filetype` varchar(255) collate latin1_general_ci default NULL,
  `hours` tinyint(3) unsigned default NULL,
  `mins` tinyint(2) unsigned default NULL,
  `secs` tinyint(2) unsigned default NULL,
  `url` text collate latin1_general_ci,
  `urltype` varchar(255) collate latin1_general_ci default NULL,
  `label1` tinyint(1) unsigned default NULL,
  `label2` tinyint(1) unsigned default NULL,
  `label3` tinyint(1) unsigned default NULL,
  `sublabels` varchar(255) collate latin1_general_ci default NULL,
  `genre` varchar(255) collate latin1_general_ci default NULL,
  `me` tinyint(1) default NULL,
  `ve` tinyint(1) default NULL,
  `ma` tinyint(1) default NULL,
  `ju` tinyint(1) default NULL,
  `sa` tinyint(1) default NULL,
  `ur` tinyint(1) default NULL,
  `ne` tinyint(1) default NULL,
  `pl` tinyint(1) default NULL,
  `er` tinyint(1) default NULL,
  `warning` tinytext collate latin1_general_ci,
  `comment` text collate latin1_general_ci,
  `privatenote` text collate latin1_general_ci,
  `vocals` enum('n','y') collate latin1_general_ci NOT NULL,
  `words` enum('n','y') collate latin1_general_ci NOT NULL,
  `malevocals` enum('n','y') collate latin1_general_ci NOT NULL,
  `femvocals` enum('n','y') collate latin1_general_ci NOT NULL,
  `foreignlang` enum('n','y') collate latin1_general_ci NOT NULL,
  `profanity` enum('n','y') collate latin1_general_ci NOT NULL,
  `volumewarning` enum('n','y') collate latin1_general_ci NOT NULL,
  `grating` enum('n','y') collate latin1_general_ci NOT NULL,
  `disturbing` enum('n','y') collate latin1_general_ci NOT NULL,
  `humorous` enum('n','y') collate latin1_general_ci NOT NULL,
  `nonewlabel` enum('n','y') collate latin1_general_ci NOT NULL default 'n',
  `temphide` enum('n','y') collate latin1_general_ci NOT NULL,
  `addlater` enum('n','y') collate latin1_general_ci NOT NULL,
  `findagain` enum('n','y') collate latin1_general_ci NOT NULL,
  `medley` enum('n','y') collate latin1_general_ci NOT NULL,
  `deleted` enum('n','y') collate latin1_general_ci NOT NULL,
  `sourcestring` text collate latin1_general_ci,
  `performerstring` text collate latin1_general_ci,
  `vocaliststring` text collate latin1_general_ci,
  `remixerstring` text collate latin1_general_ci,
  `composerstring` text collate latin1_general_ci,
  `adjectivestring` text collate latin1_general_ci,
  `genrestring` text collate latin1_general_ci,
  `leadinstrumentstring` text collate latin1_general_ci,
  `otherinstrumentstring` text collate latin1_general_ci,
  `otherstring` text collate latin1_general_ci,
  `languagestring` text collate latin1_general_ci,
  `whenadded` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `whenmodified` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`song_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci  ;";

//End of all the queries which will create the empty tables.


//We start by getting all the song and role details.

	$query_to_issue="SELECT * from vgRolesAndSongs, vgSongDetails
WHERE vgRolesAndSongs.song_id = vgSongDetails.song_id
AND vgSongDetails.urltype != 'oops'
AND vgSongDetails.label1 != 'NULL'
AND vgSongDetails.urltype NOT IN ('PRIV', 'spc', 'VGM2', 'mid')
AND vgSongDetails.deleted != 'y'
AND vgSongDetails.temphide != 'y'
ORDER BY vgSongDetails.song_id";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

//Rather than manually writing a list of the table columns, we do it automatically.
$vgsongdetails_fields=mysql_field_array($query_result);

//However, we have to manually get rid of the ones that belong only to vgRolesAndSongs.
//We also dump the "privatenote" field - because it's supposed to be a private note.
$rolesfields=array("generic_id", "spelling_id", "entity_id", "role", "song_id", "privatenote");
$vgsongdetails_insertfields=array_diff($vgsongdetails_fields, $rolesfields);
array_push($vgsongdetails_insertfields, "song_id");

$vgsongdetails_sqlvars=implode(", ", $vgsongdetails_insertfields);


//Next, we process the query results and construct the SQL insert
//queries for the output.
$numofresults=mysql_num_rows($query_result);

$querychunk=0;
$rolequerychunk=0;
$prevquerychunk=-1;
$prevrolequerychunk=-1;


//Rather than escaping single quotes, etc. in every variable, we only
//want to escape these variables, since most of the other variables can't possibly
//contains single quotes, so no need to process them all.
$strings_to_escape=array("title", "filename", "sublabels", "genre", "warning", "comment", "localfolder", "urltype", "adjectivestring", "genrestring", "leadinstrumentstring", "otherinstrumentstring", "otherstring", "languagestring");

$x=0;
$semicolon="";
$semicolon2="";

$finishedsongids=array();
$all_entityids=array();
$roles_query=array();
$songdetails_query=array();
$all_songids=array();

while ($song_info = mysql_fetch_array($query_result) )
{	
	$song_id=$song_info['song_id'];

	if ( !in_array($song_id, $finishedsongids) )
	{
		if ($prevquerychunk<$querychunk)
		{	
			$songdetails_query[$querychunk] = "$semicolon\n\nINSERT INTO

	vgSongDetails ($vgsongdetails_sqlvars)

	VALUES\n\n";
			$prevquerychunk=$querychunk;
			$semicolon=";";
		}
		$songdetails_query[$querychunk] .= " (";
		$all_songids[$x]=$song_id;
		
		foreach ($vgsongdetails_insertfields as $field)
		{	${$field}=$song_info[$field];
		}
		$localfolder="";
		
		foreach ($strings_to_escape as $string)
		{
			${$string}=mysql_real_escape_string(${$string});
		}
		
		foreach ($vgsongdetails_insertfields as $field)
		{	$songdetails_query[$querychunk] .= "'${$field}', ";
		}
		$songdetails_query[$querychunk] = substr($songdetails_query[$querychunk], 0, -2);
		$songdetails_query[$querychunk] .= "), \n\n ";
		
		$len=strlen($songdetails_query[$querychunk]);

		if ($len>50000)	//If the insert query reaches over 50 KB, then, we start another.
		{
			$songdetails_query[$querychunk] = substr($songdetails_query[$querychunk], 0, -5);
			$prevquerychunk=$querychunk;
			$querychunk++;
		}
		
	}
	array_push($finishedsongids, $song_id);
	
	if ($prevrolequerychunk<$rolequerychunk)
		{
			$roles_query[$rolequerychunk] = "$semicolon2\n\nINSERT INTO

	vgRolesAndSongs (generic_id, spelling_id, entity_id, song_id, role)

	VALUES\n\n";
			$prevrolequerychunk=$rolequerychunk;
			$semicolon2=";";
		}
		
	$song_id=$song_info[song_id];
	$generic_id = $song_info[generic_id];
	$spelling_id = $song_info[spelling_id];
	$entity_id = $song_info[entity_id];
	$role = $song_info[role];
	
	$all_entityids[$x]=$entity_id;

	$roles_query[$rolequerychunk] .= " ('$generic_id', '$spelling_id', '$entity_id', '$song_id', '$role'), \n\n ";

	$len=strlen($roles_query[$rolequerychunk]);

	if ($len>50000)
	{
		$roles_query[$rolequerychunk] = substr($roles_query[$rolequerychunk], 0, -5);
		$prevrolequerychunk=$rolequerychunk;
		$rolequerychunk++;
	}
	
	$x++;
}

	$all_entityids=array_unique($all_entityids);
	sort($all_entityids);
	$entityids_forsql=implode(", ", $all_entityids);
	
	$finalrolesquery=implode(" ", $roles_query);
	$finalrolesquery = substr($finalrolesquery, 0, -5);
	$finalrolesquery .= ";\n\n";

	$finalsongdetails_query=implode(" ", $songdetails_query);
	$finalsongdetails_query = substr($finalsongdetails_query, 0, -5);
	$finalsongdetails_query .=";\n\n";
	

	//Then, we use the collection of all song IDs to figure out what 
	//tagmap entries are needed.
	$songids_forsql=implode(", ", $all_songids);
	
		$query_to_issue="SELECT * from songtagmap
WHERE songtagmap.song_id IN ($songids_forsql)
ORDER BY songtagmap.song_id";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

//And now we start creating the Tagmap insert query (or queries).

$x=0;
$querychunk=0;
$tagquerychunk=0;
$prevquerychunk=-1;
$prevtagquerychunk=-1;
$semicolon="";

//However, there might actually not be any tags, in which case we
//don't need to output the tag or tagmap insert queries.

if (mysql_num_rows($query_result) > 0)
{
	$output_tagqueries="true";
	
	while ($tagmap_info = mysql_fetch_array($query_result) )
	{
		if ($prevquerychunk<$querychunk)
		{				
			$tagmapquery[$querychunk] = "$semicolon\n\n INSERT INTO songtagmap (tagmap_id, song_id, tag_id, tagtypenum) VALUES ";
			$prevquerychunk=$querychunk;
			$semicolon=";";
		}

		$tagmap_id=$tagmap_info['tagmap_id'];
		$song_id=$tagmap_info['song_id'];
		$tag_id=$tagmap_info['tag_id'];
		$all_tagids[$x]=$tag_id;
		$tagtypenum=$tagmap_info['tagtypenum'];

		$tagmapquery[$querychunk] .= " ('$tagmap_id', '$song_id', '$tag_id', '$tagtypenum'), \n\n ";

		$x++;
		
		$len=strlen($tagmapquery[$querychunk]);
		if ($len>50000)
		{
			$tagmapquery[$querychunk] = substr($tagmapquery[$querychunk], 0, -5);
			$prevquerychunk=$querychunk;
			$querychunk++;
		}
	
	}

	$finaltagmapquery=implode (" ", $tagmapquery);
	$finaltagmapquery=substr($finaltagmapquery, 0, -5);
	$finaltagmapquery.= ";\n\n";
	
	$all_tagids=array_unique($all_tagids);
	$tagids_forsql=implode(", ", $all_tagids);
	
	$semicolon="";
	
	//Next, we get the tags.
	$query_to_issue="SELECT * from Tags
WHERE Tags.tag_id IN ($tagids_forsql)
ORDER BY Tags.tag_id";

	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

	while ($tag_info = mysql_fetch_array($query_result) )
	{
		if ($prevtagquerychunk<$tagquerychunk)
		{
			$tagquery[$tagquerychunk] = "$semicolon\n\n INSERT INTO Tags (tag_id, tag_name, whenadded) VALUES ";
			$prevtagquerychunk=$tagquerychunk;
			$semicolon=";";
		}
		
		$tag_id=$tag_info['tag_id'];
		$tag_name=$tag_info['tag_name'];
		$whenadded=$tag_info['whenadded'];
		
		$tagquery[$tagquerychunk] .= " ('$tag_id', '$tag_name', '$whenadded'), \n\n ";

		$len=strlen($tagquery[$tagquerychunk]);

		if ($len>50000)
		{
			$tagquery[$tagquerychunk] = substr($tagquery[$tagquerychunk], 0, -5);
			$prevquerychunk=$tagquerychunk;
			$tagquerychunk++;
		}
	}
	$finaltagquery=implode(" ", $tagquery);
	$finaltagquery=substr($finaltagquery, 0, -5);
	$finaltagquery .= ";\n\n";
}


//Now we get the needed name URLs.  We have to do a separate query to get all the names
//because sources get left out (unless they have a name URL associated with them).
		$query_to_issue="SELECT vgnames.spelling_id, vgnames.name, vgnames.abbrev, vgnames.entity_id, vgnames.nametype, vgnames.namecat, vgnames.namecomment, vgnames.whenadded, vgnameurls.nameurl_id, vgnameurls.entity_id as url_entity_id, vgnameurls.spelling_id as url_spelling_id, vgnameurls.nameurl, vgnameurls.nameurltype, vgnameurls.nameurlcomment, vgnameurls.whenadded as url_whenadded from vgnames, vgnameurls
WHERE vgnameurls.entity_id = vgnames.entity_id
AND vgnames.entity_id IN ($entityids_forsql)
AND vgnames.temphide = 'n'
AND vgnames.permhide = 'n'
AND vgnameurls.temphide = 'n'
AND vgnameurls.permhide = 'n'

ORDER BY vgnames.spelling_id";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());


$x=0;
$semicolon="";
$semicolon2="";

$urlquerychunk=0;
$prevurlquerychunk=-1;

$strings_to_escape=array("nameurl", "nameurlcomment", "nameurltype");

$temphide="n";
$permhide="n";
$x=0;

$entity_id=0;

$finishednameurls=array();

while ($name_info = mysql_fetch_array($query_result) )
{		
	if ($prevurlquerychunk<$urlquerychunk)
		{
			$urlquery[$urlquerychunk] = "$semicolon2\n\nINSERT INTO

	vgnameurls (nameurl_id, entity_id, spelling_id, nameurl, nameurltype, nameurlcomment, temphide, permhide, whenadded)

	VALUES\n\n";
			$prevurlquerychunk=$urlquerychunk;
			$semicolon2=";";
		}
	$nameurl = $name_info[nameurl];
	
	if (!in_array($nameurl, $finishednameurls) )
	{	
		$nameurl_id=$name_info[nameurl_id];
		$entity_id = $name_info[url_entity_id];

		$spelling_id = $name_info[url_spelling_id];
		$nameurltype = $name_info[nameurltype];
		$nameurlcomment = $name_info[nameurlcomment];
		$whenadded = $name_info[url_whenadded];	

		foreach ($strings_to_escape as $string)
		{
			${$string}=mysql_real_escape_string(${$string});
		}
		
		$urlquery[$urlquerychunk] .= " ('$nameurl_id', '$entity_id', '$spelling_id', '$nameurl', '$nameurltype', '$nameurlcomment', '$temphide', '$permhide', '$whenadded'), \n\n ";

		$len=strlen($urlquery[$urlquerychunk]);

		if ($len>50000)
		{
			$urlquery[$urlquerychunk] = substr($urlquery[$urlquerychunk], 0, -5);
			$prevurlquerychunk=$urlquerychunk;
			$urlquerychunk++;
		}
	}
	array_push($finishednameurls, $nameurl);

	$x++;

}
	$finalurlquery=implode(" ", $urlquery);
	$finalurlquery=substr($finalurlquery, 0, -5);
	$finalurlquery .= ";\n\n";


	$query_to_issue="SELECT vgnames.spelling_id, vgnames.name, vgnames.abbrev, vgnames.entity_id, vgnames.nametype, vgnames.namecat, vgnames.namecomment, vgnames.whenadded from vgnames
WHERE vgnames.entity_id IN ($entityids_forsql)
AND vgnames.temphide = 'n'
AND vgnames.permhide = 'n'
ORDER BY vgnames.spelling_id";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());


	$querychunk=0;
$prevquerychunk=-1;
$prevspelling_id=null;
$finishedspellingids=array();

	$vgnames_vars=array("spelling_id", "name", "abbrev", "entity_id", "nametype", "namecat", "namecomment", "whenadded");

	$vgnamestoget_forsql=implode(", ", $vgnames_vars);

$vgnames_varstoinsert=$vgnames_vars;
array_push($vgnames_varstoinsert, "temphide");
array_push($vgnames_varstoinsert, "permhide");

$vgnames_sqlvars=implode(", ", $vgnames_varstoinsert);

$strings_to_escape=array("name", "abbrev", "namecat", "namecomment");

while ($name_info = mysql_fetch_array($query_result) )
{		
	$spelling_id=$name_info['spelling_id'];
	
	if (!in_array($spelling_id, $finishedspellingids) )
	{
		if ($prevquerychunk<$querychunk)
		{	
			$vgnames_query[$querychunk] = "$semicolon\n\nINSERT INTO

	vgNames ($vgnames_sqlvars)

	VALUES\n\n";
			$prevquerychunk=$querychunk;
			$semicolon=";";
		}
		$vgnames_query[$querychunk] .= " (";
		
		foreach ($vgnames_vars as $field)
		{	${$field}=$name_info[$field];
		}
		
		foreach ($strings_to_escape as $string)
		{
			${$string}=mysql_real_escape_string(${$string});
		}
		
		foreach ($vgnames_varstoinsert as $field)
		{	$vgnames_query[$querychunk] .= "'${$field}', ";
		}
		$vgnames_query[$querychunk] = substr($vgnames_query[$querychunk], 0, -2);
		$vgnames_query[$querychunk] .= "), \n\n ";
		
		$len=strlen($vgnames_query[$querychunk]);

		if ($len>50000)	//If the insert query reaches over 50 KB, then, we start another.
		{
			$vgnames_query[$querychunk] = substr($vgnames_query[$querychunk], 0, -5);
			$prevquerychunk=$querychunk;
			$querychunk++;
		}
	}
	array_push($finishedspellingids, $spelling_id);
}
	
	$finalnamequery=implode(" ", $vgnames_query);
	$finalnamequery=substr($finalnamequery, 0, -5);
	$finalnamequery.= ";\n\n";

	
?>

<html><head><title>Public DB Info Exported</title>
<link rel=stylesheet href='css/a.css' type='text/css'>
</head>
<body><center>
<?php

ListNav();

?>
<p>
<h1>Public DB Info Exported</h1>
<p>
<textarea type="text" name="exportedquery" rows=20 cols=75><?php 

echo $create_songdetails_table;

echo $create_rolesandsongs_table;

echo $create_songtagmap_table;

echo $create_tags_table;

echo $create_vgnames_table;

echo $create_vgnameurls_table;

echo $finalsongdetails_query;
echo $finalrolesquery; 

if ($output_tagqueries)
{	echo $finaltagmapquery;
	echo $finaltagquery;
}
echo $finalnamequery;
echo $finalurlquery;

?></textarea>