<?php

require ("taglib.php");

$menames=array("me", "mer", "merc", "mercury");
$venames=array("ve", "ven", "venus");
$manames=array("ma", "mar", "mars");
$junames=array("ju", "jup", "jupiter");
$sanames=array("sa", "sat", "saturn");
$urnames=array("ur", "ura", "uranus");
$nenames=array("ne", "nep", "neptune");
$plnames=array("pl", "plu", "pluto");
$ernames=array("er", "eri", "eris");

$allplanames=array_merge ($menames, $venames, $manames, $junames, $sanames, $urnames, $nenames, $plnames, $ernames);


$possiblecomparisons = array ("<", ">", "=", "<=", ">=");


$displaylinkscommands = array ("dl", "displaylinks");
$displayeditlinkscommands = array("d", "e", "de", "ed", "del", "edit", "displayeditlinks");

$outputplaylistcommands = array ("op", "playlist", "oplaylist");
$outputsearchcommands = array ("os", "search", "osearch");
$outputeditlinkscommands = array("elo", "oel", "outputeditlinks");


$sourcecommands = array ("s", "so", "source", "sources");
$sourcelikecommands = array ("sol", "solike", "sourcelike");

$allsourcecommands = array_merge($sourcecommands, $sourcelikecommands);


$performercommands = array ("p", "pe", "performer", "performers");
$performerlikecommands = array ("pel", "performerlike");

$allperformercommands = array_merge($performercommands, $performerlikecommands);


$vocalistcommands = array ("v", "vo", "vocalist", "vocalists");
$vocalistlikecommands = array ("vl", "vol", "vocalistlike");

$allvocalistcommands = array_merge($vocalistcommands, $vocalistlikecommands);


$remixercommands = array ("r", "re", "remixer", "remixers");
$remixerlikecommands = array ("rl", "rel", "remixerlike");

$allremixercommands = array_merge($remixercommands, $remixerlikecommands);


$composercommands = array ("c", "co", "composer", "composers");
$composerlikecommands = array ("cl", "col", "composerlike");

$allcomposercommands = array_merge($composercommands, $composerlikecommands);


$anyrolecommands = array ("ar", "any", "anyrole");
$anyroleorcommands = array ("aror", "anyor", "anyroleor");
$anyrolelikecommands = array("arl", "anyrl", "anyrolelike");

$allanyrolecommands = array_merge($anyrolecommands, $anyrolelikecommands, $anyroleorcommands);


$alllikecommands = array_merge ($sourcelikecommands, $performerlikecommands, $vocalistlikecommands, $remixerlikecommands, $composerlikecommands, $anyrolelikecommands);


$roletablecommands = array_merge($allsourcecommands, $allperformercommands, $allvocalistcommands, $allremixercommands, $allcomposercommands, $allanyrolecommands);


$label1commands = array ("l1", "label1");
$label2commands = array ("l2", "label2");
$label3commands = array ("l3", "label3");
$eachlabelcommands = array ("la", "labels");
$eachlabelandsublabelcommands = array ("ls", "las");

$label1or2commands = array ("l12", "label12");
$label2or3commands = array ("l23", "label23");

$alllabelcommands = array_merge ($label1commands, $label2commands, $label3commands, $eachlabelcommands, $eachlabelandsublabelcommands, $label1or2commands, $label2or3commands);

$nullcommands = array("nu", "nul", "null");

$sublabelcommands = array ("sl", "su", "sub", "subl", "sublabel");
$sublabelorcommands = array ("slo", "suo", "subor", "sublabelor");

$sublabelxcommands = array ("slx", "sux", "subx", "sublabelx");

$localfoldercommands = array("lo", "loc", "fol", "path", "locfol", "localfolder");

//$filesizecommands = array("fs", "fsize", "filesize");
//$filesizekbcommands = array("fsk", "fskb", "fsizekb", "filesizekb");

$genrecommands = array ("g", "ge", "genre");

$titlecommands = array ("t", "title");
$filenamecommands = array ("f", "fn", "fnl", "file", "filename");

$titleorcommands = array ("to", "tor", "titleor");
$filenameorcommands = array ("fo", "fno", "for", "fnor", "fileor");

$titlexcommands = array ("tx", "titlex", "exactitle");
$filenamexcommands = array ("fx", "fnx", "filex", "filenamex", "exactfile", "exactfilename");

$extcommands = array ("x", "xt", "ext", "ft", "filetype");
$urltypecommands = array ("u", "ut", "urltype");


$hascommands = array ("y", "is", "has", "yes");
$hasntcommands = array ("n", "no", "not", "isnt", "hasnt");
$attributes = array ("vocals", "words", "malevocals", "femvocals", "foreignlang", "profanity", "volumewarning", "grating", "disturbing", "humorous", "medley", "temphide", "addlater", "findagain");


$minequalscommands = array("m", "min", "mins", "minute", "minutes");
$secequalscommands = array ("se", "sec", "secs", "second", "seconds");
$hourequalscommands = array("h", "hr", "hour", "hours");

$lengthequalscommands = array_merge ($minequalscommands, $secequalscommands, $hourequalscommands);


$minlesscommands = array ("m<", "ml", "min<", "minute<", "minutes<");
$seclesscommands = array ("s<", "sle", "sec<");
$hourlesscommands = array ("h<", "hl", "hr<");

$minmorecommands = array ("m>", "mg", "min>", "minute>", "minutes>");
$secmorecommands = array ("s>", "sg", "sec>");
$hourmorecommands = array ("h>", "hg", "hr>");

$temphidecommands = array("hi", "th", "tem", "temp", "temph", "temphide", "hid", "hide");
$findagaincommands = array("find", "findagain", "again", "ag", "aga", "fi", "fa");
$addlatercommands = array("ad", "add", "addlater", "later");

$lengthcomparecommands = array_merge ($minlesscommands, $seclesscommands, $hourlesscommands, $minmorecommands, $secmorecommands, $hourmorecommands);

$anytagcommands = array("ta", "tag", "tags", "at", "anyt", "anytag");
$anytagorcommands = array("tao", "tago", "tagso", "tagsor", "tagor", "ato", "ator", "anytagor");

$adjectivetagcommands = array("ad", "adj", "adjt", "adjective", "adjectives");
$adjectivetagorcommands = array("adto", "adjo", "adjor", "adjto", "adjtor", "adjectiveor", "adjectivesor");

$languagetagcommands = array ("lan", "lang", "langs", "language", "languages");
$languagetagorcommands = array("lano", "lanor", "langor", "languageor", "languagesor");

$genretagcommands = array("gen", "genret", "genretags");
$genretagorcommands = array("geno", "genor", "genreor");

$leadinstrumentagcommands = array ("li", "linst", "lin", "leadin", "leadinst", "leadinstrument", "leadinstruments");
$leadinstrumentagorcommands = array("lio", "lior", "leado", "leador", "leadinstrumentor", "leadinstrumentsor");

$otherinstrumentagcommands = array("oi", "oin", "oinst", "otherinstrument", "otherinstruments");
$otherinstrumentagorcommands = array("oio", "oior", "oinstor", "otherinstrumentor", "otherinstrumentsor");

$othertagcommands = array ("ot", "oth", "otht", "othert", "othertag", "othertags");
$othertagorcommands = array ("oto", "otor", "othertagor", "othertagsor");

$anyinstrumentagcommands = array("ai", "ain", "ainst", "anyinstrument", "anyinstruments", "in", "inst", "instrument", "instruments");
$anyinstrumentagorcommands = array("aio", "aior", "ayior", "anyior", "anyinstrumentor", "inor", "instor", "instrumentor");


$allanytagcommands = array_merge($anytagcommands, $anytagorcommands);
$alladjectivecommands=array_merge($adjectivetagcommands, $adjectivetagorcommands);

$allgenrecommands = array_merge($genretagorcommands, $genretagorcommands);

$allanyinstrumentcommands = array_merge($anyinstrumentagcommands, $anyinstrumentagorcommands);
$allleadinstrumentcommands = array_merge($leadinstrumentagcommands, $leadinstrumentagorcommands);
$allotherinstrumentcommands = array_merge($otherinstrumentagcommands, $otherinstrumentagorcommands);
$allothertagcommands = array_merge($othertagcommands, $othertagorcommands);
$alllanguagetagcommands = array_merge($languagetagcommands, $languagetagorcommands);

$alltagorcommands = array_merge($anytagorcommands, $languagetagorcommands, $genretagorcommands, $leadinstrumentagorcommands, $otherinstrumentagorcommands, $othertagorcommands, $anyinstrumentagorcommands);

$tagtablecommands = array_merge($anytagcommands, $anytagorcommands, $adjectivetagorcommands, $languagetagcommands, $languagetagorcommands, $genretagcommands, $genretagorcommands, $leadinstrumentagorcommands, $otherinstrumentagorcommands, $othertagorcommands, $anyinstrumentagorcommands, $adjectivetagcommands, $leadinstrumentagcommands, $otherinstrumentagcommands, $othertagcommands, $anyinstrumentagcommands);


$list_allcommandarrays=array ("allplanames", "possiblecomparisons", "displaylinkscommands", "displayeditlinkscommands", "outputplaylistcommands", "outputsearchcommands", "outputeditlinkscommands", "sourcecommands", "sourcelikecommands", "performercommands", "performerlikecommands", "vocalistcommands", "vocalistlikecommands", "remixercommands", "remixerlikecommands", "composercommands", "composerlikecommands", "anyrolecommands", "anyrolelikecommands", "label1commands", "label2commands", "label3commands", "eachlabelcommands", "eachlabelandsublabelcommands", "label1or2commands", "label2or3commands", "nullcommands", "sublabelcommands", "sublabelorcommands", "sublabelxcommands", "localfoldercommands", "genrecommands", "titlecommands", "filenamecommands", "titleorcommands", "filenameorcommands", "titlexcommands", "filenamexcommands", "extcommands", "urltypecommands", "hascommands", "hasntcommands", "minequalscommands", "secequalscommands", "hourequalscommands", "lengthequalscommands", "minlesscommands", "seclesscommands", "hourlesscommands", "minmorecommands", "secmorecommands",  "hourmorecommands", "temphidecommands", "findagaincommands", "addlatercommands", "attributes", "anytagcommands", "anytagorcommands", "adjectivetagorcommands", "languagetagorcommands", "genretagorcommands", "leadinstrumentagorcommands", "otherinstrumentagorcommands", "othertagorcommands", "anyinstrumentagorcommands", "languagetagcommands", "genretagcommands", "adjectivetagcommands", "leadinstrumentagcommands", "otherinstrumentagcommands", "othertagcommands", "anyinstrumentagcommands");

$allcommands = array();

foreach ($list_allcommandarrays as $arr)
{
	$allcommands = array_merge( $allcommands, ${$arr} );
}

function TagSubquery ($inornot, $likeorin, $tagidnums, $tagtypestuff)
{
	$res="\nAND vgSongDetails.song_id $inornot
(
		SELECT vgSongDetails.song_id 
		FROM vgSongDetails, tags, songtagmap 
		WHERE vgSongDetails.urltype !='oops' 
		AND vgSongDetails.deleted = 'n'
		
		AND vgSongDetails.song_id = songtagmap.song_id 
		AND Tags.tag_id = songtagmap.tag_id
		AND
		( 
			(	Tags.tag_name $likeorin ($tagidnums)  $tagtypestuff
			)
		)
)";
	return $res;
}


function GetTagidStringFromTagArr($arr)
{	global $array_existingtagsandids;

	$numoftags=count($arr);

	$x=0;
	while ($x<$numoftags)
	{	$tagname=$arr[$x];
		$thistagid[$x]=$array_existingtagsandids[$tagname];
		$tagids .= "$thistagid[$x], ";
		$x++;
	}
	$tagids=substr($tagids, 0, -2);
	return $tagids;
}


function ParseSearchQuery($searchquery)
{	global $list_allcommandarrays;

	foreach ($list_allcommandarrays as $arr)
	{	global ${$arr};
	}
	
    global $allsourcecommands,   $allperformercommands,   $allvocalistcommands,  $allremixercommands,  $allcomposercommands, $allanyrolecommands, $alllikecommands, $roletablecommands, $alllabelcommands,     
  $lengthcomparecommands, $tagtablecommands, $allcommands, $num_of_args, $indiv_args, $outlist, $inlist, $roletablequery, $displaylinks, $displayeditlinks, $outputeditfile, $outputsearch, $outputplaylist, $getsongidornot, $allanytagcommands, $tagtablequery, $alladjectivecommands, $allgenrecommands, $allanyinstrumentcommands, $allleadinstrumentcommands, $allotherinstrumentcommands, $allothertagcommands, $allanyinstrumentcommands, $alllanguagetagcommands, $alltagorcommands;

	$searchquery=ereg_replace("\n", ";\n", $searchquery);

	$indiv_commands=explode(";", $searchquery);

	array_walk($indiv_commands,trim_value);

	$num_of_commands=count($indiv_commands);


	$x=0;

	while ($x<$num_of_commands)
	{
		$splitcommand=explode(" ", $indiv_commands[$x]);
		$thiscommand=array_shift($splitcommand);
		$thiscommand=strtolower($thiscommand);
		$len=strlen($thiscommand);

		$args=substr($indiv_commands[$x],$len);
		
		$indiv_args=explode(",", $args);

		array_walk($indiv_args,trim_value);

		$num_of_args=count($indiv_args);

		$test=substr($thiscommand, 0, 1);
		if ($test=="!")
		{	$negcommand=substr($thiscommand,1);
		}

	if ( in_array($thiscommand, $allcommands) )
	{
		if ( in_array($thiscommand, $tagtablecommands) )
		{	
			$tagtablequery="true";
			
			GetCachedTags();
			
			$tagtablequery=true;
			
			$outlist = array();
			$inlist = array();

			$likeorin="IN";
			$enclosure="\"";
			
			if ( in_array($thiscommand,$alllikecommands) )
			{
				$likeorin="LIKE";
				$enclosure="\"%";
			}
			array_walk($indiv_args, ArrayWalkInOrNot);
			$tagtypestuff = "AND songtagmap.tagtypenum IN ";
						
			if ( in_array($thiscommand,$allanytagcommands ) )
			{	$tagtypestuff = "";
			}
			else if ( in_array($thiscommand,$alladjectivecommands) )
			{	$tagtypestuff .= "(1, 2)";
			}
			else if ( in_array($thiscommand,$allgenrecommands) )
			{	$tagtypestuff .= "(3, 4)";
			}
			else if ( in_array($thiscommand,$allleadinstrumentcommands) )
			{	$tagtypestuff .= "(5, 6)";
			}
			else if ( in_array($thiscommand,$allotherinstrumentcommands) )
			{	$tagtypestuff .= "(7, 8)";
			}
			else if ( in_array($thiscommand,$allothertagcommands) )
			{	$tagtypestuff .= "(9, 10)";
			}	
			else if ( in_array($thiscommand,$alllanguagetagcommands) )
			{	$tagtypestuff .= "(11, 12)";
			}
			else if ( in_array($thiscommand,$allanyinstrumentcommands) )
			{	$tagtypestuff .= "(5, 6, 7, 8)";
			}
			
			if (!empty ($inlist) )
			{	
				//	$intagids=GetTagidStringFromTagArr($inlist);
				//	echo "Intagids: $intagids";
				array_walk($inlist,EncloseInSomething, $enclosure);
				$num_of_in=count($inlist);
				$regluedin=implode(", ", $inlist);
			}
			if (!empty ($outlist) )
			{
				array_walk($outlist,EncloseInSomething, $enclosure);
				$num_of_out=count($outlist);
				$regluedout=implode(", ", $outlist);
			}
				
			if ( in_array($thiscommand, $alltagorcommands) )
			{
				if (!$prevtagcommandissued)
				{				
					if ( isset($regluedin) )
					{	if ($likeorin=="IN")
						{
							$query_part2 .= "\nAND ( (Tags.tag_name $likeorin ($regluedin) ) $tagtypestuff )";
						}
						else
						{	$y=0;
							$query_part2 .= "\nAND ( (";
							while ($y<$num_of_in)
							{	$thisarg=$inlist[$y];
								if ($y>0)
								{	$query_part2 .= "OR";
								}
								$query_part2 .=  " ( Tags.tag_name $likeorin ($thisarg) ) ";
								$y++;
							}
							$query_part2 .= ") $tagtypestuff )";
						}
					}
					if ( isset($regluedout) )
					{
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $regluedout, $tagtypestuff);
					}
				}
				else if ($prevtagcommandissued)
				{	if ( isset($regluedin) )
					{	
						$query_part2 .= TagSubquery("IN", $likeorin, $regluedin, $tagtypestuff);
					}
					if ( isset($regluedout) )
					{
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $regluedout, $tagtypestuff);	
					}
				}
			}
			else if (! in_array($thiscommand, $alltagorcommands) ) //If it's not an "or" command...
			{	if ($likeorin=="IN")
				{	$likeorin="=";
				}
				$z=0;
				if ( !empty ($inlist) )
				{	if (!$prevtagcommandissued)
					{	$thisarg=$inlist[0];
						$query_part2 .= "\nAND ( (Tags.tag_name $likeorin $thisarg ) $tagtypestuff )";
						$z=1;
					}				
					while ($z<$num_of_in)
					{
						$thisarg=$inlist[$z];
						$query_part2 .= TagSubquery("IN", $likeorin, $thisarg, $tagtypestuff);
						$z++;
					}
					$z=0;
				}
				if ( !empty ($outlist) )
				{
					while ($z<$num_of_out)
					{
						$thisarg=$outlist[$z];
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $thisarg, $tagtypestuff);
						$z++;
					}
				}
			}
			unset($regluedin);
			unset($regluedout);
				
			$prevtagcommandissued="true";
		
		}
		
		if ( in_array($thiscommand,$roletablecommands) )
		{	$roletablequery=true;
			
			$outlist = array();
			$inlist = array();

			$likeorin="IN";
			$enclosure="\"";

			if ( in_array($thiscommand,$alllikecommands) )
			{
				$likeorin="LIKE";
				$enclosure="\"%";
			}
			array_walk($indiv_args, ArrayWalkInOrNot);

			$rolestuff = "AND vgRolesAndSongs.role = ";
			if ( in_array($thiscommand,$allanyrolecommands ) )
			{	$rolestuff = "";
			}
			else 
			if ( in_array($thiscommand,$allsourcecommands) )
			{	$rolestuff .= "'source'";
			}
			else if (in_array($thiscommand,$allperformercommands) )
			{	$rolestuff .= "'performer'";
			}
			else if (in_array($thiscommand,$allvocalistcommands) )
			{	$rolestuff .= "'vocalist'";
			}
			else if (in_array($thiscommand,$allremixercommands) )
			{	$rolestuff .= "'remixer'";
			}
			else if (in_array($thiscommand,$allcomposercommands) )
			{	$rolestuff .= "'composer'";
			}
			if (!empty ($inlist) )
			{
				array_walk($inlist,EncloseInSomething, $enclosure);
				$num_of_in=count($inlist);
				$regluedin=implode(", ", $inlist);
			}
			if (!empty ($outlist) )
			{
				array_walk($outlist,EncloseInSomething, $enclosure);
				$num_of_out=count($outlist);
				$regluedout=implode(", ", $outlist);
			}
			if ( isset($regluedin) )
			{	if ($likeorin=="IN")
				{
					$query_part2 .= "\nAND ( (vgNames.name $likeorin ($regluedin) OR vgNames.abbrev $likeorin ($regluedin) ) $rolestuff )";
				}
				else
				{	$y=0;
					$query_part2 .= "\nAND ( (";
					while ($y<$num_of_in)
					{	$thisarg=$inlist[$y];
						if ($y>0)
						{	$query_part2 .= "OR";
						}
						$query_part2 .=  " ( vgNames.name $likeorin ($thisarg) OR vgNames.abbrev $likeorin ($thisarg) ) ";				$y++;
					}
					$query_part2 .= ") $rolestuff )";
				}
			}
			if ( isset($regluedout) )
			{
				$query_part2 .= "AND vgSongDetails.song_id NOT IN 
(
	SELECT vgSongDetails.song_id 
	FROM vgSongDetails, vgNames, vgRolesAndSongs 
	WHERE vgSongDetails.urltype !='oops'
	AND vgSongDetails.deleted = 'n'
	AND vgRolesAndSongs.entity_id = vgNames.entity_id 
	AND vgSongDetails.song_id = vgRolesAndSongs.song_id
	AND
	( 
		(	vgNames.name $likeorin ($regluedout) 
			OR 
			vgNames.abbrev $likeorin ($regluedout)
		)
	)
)";
			}
				unset($regluedin);
				unset($regluedout);
				$prevrolecommandissued="true";
		}
		else if ( in_array($thiscommand, $lengthcomparecommands ) )
		{
			if ( in_array($thiscommand,$minlesscommands) )
			{	$query_part2 .= ConstructLengthComparisonQuery("mins", "<");
			}
			else if (in_array($thiscommand,$seclesscommands) )
			{	$query_part2 .= ConstructLengthComparisonQuery("secs", "<");
			}
			else if ( in_array($thiscommand,$hourlesscommands) )
			{	$query_part2 .= ConstructLengthComparisonQuery("hours", "<");
			}
			else if ( in_array($thiscommand,$minmorecommands) )
			{	$query_part2 .= ConstructLengthComparisonQuery("mins", ">");
			}
			else if ( in_array($thiscommand,$secmorecommands) )
			{	$query_part2 .= ConstructLengthComparisonQuery("secs", ">");
			}
			else if ( in_array($thiscommand,$hourmorecommands))
			{	$query_part2 .= ConstructLengthComparisonQuery("hours", ">");
			}
		}
		else
		if ( in_array($thiscommand,$displaylinkscommands) )
		{	$displaylinks=true;
		}
		else
		if ( in_array($thiscommand,$displayeditlinkscommands) )
		{	$displayeditlinks=true;
		}
		else
		if ( in_array($thiscommand,$outputeditlinkscommands) )
		{	$displayeditlinks=true;
			$outputeditfile=true;
		}
		else
		if ( in_array($thiscommand,$outputplaylistcommands) )
		{	$outputplaylist=true;
		}
		else if ( in_array($thiscommand,$temphidecommands) )
		{	$query_part2 .= "AND temphide='y'\n";
		}
		else if ( in_array($thiscommand,$findagaincommands) )
		{	$query_part2 .= "AND findagain='y'\n";
		}
		else if ( in_array($thiscommand,$addlatercommands) )
		{	$query_part2 .= "AND addlater='y'\n";
		}
		else
		if ( in_array($negcommand,$allplanames) )
		{	ArrayWalkPlaToNum($negcommand);
			$negcommand=NumToPla($negcommand);

			$query_part2 .= "AND ( ( $negcommand = -9) OR ( $negcommand = 0 ) )\n";
			unset($negcommand);
		}
		if ( in_array($thiscommand,$allplanames) )
		{	ArrayWalkPlaToNum($thiscommand);
			$thiscommand=NumToPla($thiscommand);

			if ($num_of_args==1)
			{	$indiv_args=explode(" ", $indiv_args[0]);
				array_walk($indiv_args,trim_value);
				$thisarg=$indiv_args[0];
				if ($thisarg=="")
				{	$query_part2 .= "AND ( ($thiscommand = -8) OR ($thiscommand > 0 ) )\n";
				}

				$num_of_args=count($indiv_args);
				if ($num_of_args==2)
				{	if ( in_array($thisarg,$possiblecomparisons) )
					{	$comparison=$thisarg;
					}
					else
					{	$comparison="=";
					}
					$thisarg=$indiv_args[1];
				}
				if ($num_of_args==1)
				{	$comparison="=";
				}
				if ( ( is_numeric($thisarg) && $thisarg<5 ) || $thisarg=="x" )
				{	if ($thisarg=="x")
					{	$thisarg="-9";
					}
					if ($thisarg==0)
					{	$thisarg="-8";
					}
					$query_part2 .= "AND ( ($thiscommand $comparison $thisarg) )\n";
				}
			}
		}
		if ( in_array($thiscommand,$lengthequalscommands) )
		{
			$outlist = array();
			$inlist = array();

			array_walk($indiv_args, ArrayWalkInOrNot);

			if (!empty ($inlist) )
			{	$regluedin=implode(", ", $inlist);
			}
			if (!empty ($outlist) )
			{	$regluedout=implode(", ", $outlist);
			}

			if (in_array($thiscommand,$minequalscommands) )
			{
				$thisfield = "mins";
			}
			else if (in_array($thiscommand,$secequalscommands) )
			{	$thisfield = "secs";
			}
			else if (in_array($thiscommand,$hourequalscommands) )
			{	$thisfield = "hours";
			}
			if (isset($regluedin))
			{
				$query_part2 .= "\nAND vgSongDetails.$thisfield IN ($regluedin)";
			}
			if (isset($regluedout))
			{	$query_part2 .= "\nAND vgSongDetails.$thisfield NOT IN ($regluedout)";
			}

			unset($regluedin);
			unset($regluedout);
		}

		else
		if ( in_array($thiscommand,$extcommands) || in_array($thiscommand,$urltypecommands) )
		{
			$outlist = array();
			$inlist = array();

			array_walk($indiv_args, ArrayWalkInOrNot);

			array_walk($outlist,EncloseInSomething, "\"");
			array_walk($inlist,EncloseInSomething, "\"");

			if (!empty ($inlist) )
			{	$regluedin=implode(", ", $inlist);
			}
			if (!empty ($outlist) )
			{	$regluedout=implode(", ", $outlist);
			}

			$reglued_args=implode(", ", $indiv_args);
			
			if ( in_array($thiscommand,$extcommands) )
			{	$thisfield = "filetype";
			}
			else if ( in_array($thiscommand,$urltypecommands) )
			{	$thisfield = "urltype";
			}

			if (isset($regluedin))
			{
				$query_part2 .= "\nAND vgSongDetails.$thisfield IN ($regluedin)";
			}
			if (isset($regluedout))
			{	$query_part2 .= "\nAND vgSongDetails.$thisfield NOT IN ($regluedout)";
			}

			unset($regluedin);
			unset($regluedout);
		}

		else if ( in_array($thiscommand,$nullcommands) )
		{	$query_part2 .= "\nAND label1 IS NULL";
		}
		else if ( in_array($thiscommand,$sublabelcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("sublabels", "LIKE", "SingleQuoted", false);
		}
		else if ( in_array($thiscommand,$sublabelxcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("sublabels", "=", "SingleQuoted", false);
		}
		else if ( in_array($thiscommand,$sublabelorcommands ) )
		{	$query_part2 .= ConstructTextSearchQuery("sublabels", "LIKE", "SingleQuoted", true);
		}
		else if ( in_array($thiscommand,$titlecommands) )
		{	$query_part2 .= ConstructTextSearchQuery("title", "LIKE", "SingleQuoted", false);
		}
		else if ( in_array($thiscommand,$titleorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("title", "LIKE", "SingleQuoted", true);
		}
		else if ( in_array($thiscommand,$genrecommands) )
		{	$query_part2 .= ConstructTextSearchQuery("genre", "LIKE", "SingleQuoted", true);
		}
		else if ( in_array($thiscommand, $titlexcommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("title", "=", "SingleQuoted", false);
		}
		else if ( in_array($thiscommand,$filenamecommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("filename", "LIKE", "SingleQuoted", false);
		}
		else if ( in_array($thiscommand,$filenameorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("filename", "LIKE", "SingleQuoted", true);
		}
		else if ( in_array($thiscommand,$filenamexcommands)  )
		{
			$query_part2 .= ConstructTextSearchQuery("filename", "=", "SingleQuoted", false);
		}
		else if ( in_array($thiscommand,$localfoldercommands) )
		{
			$y=0;
			$query_part2 .= "AND ( ";
			while ($y<$num_of_args)
			{	$rawlocalfolder=$indiv_args[$y];
				$fixedlocalfolder=BackToForwardSlashes($rawlocalfolder);
				$fixedlocalfolder=ConvertFirefoxFormat($fixedlocalfolder);
				if (!FileLocalhostHere($fixedlocalfolder) )
				{	$fixedlocalfolder=AddFileLocalhost($fixedlocalfolder);
				}
				$fixedlocalfolder=ConvertSpacesTo20($fixedlocalfolder);
				$fixedlocalfolder=RemoveFinalSlash($fixedlocalfolder);
				if ($y>0)
				{	$query_part2 .= " OR ";
				}
				$query_part2 .= "(localfolder = \"$fixedlocalfolder\")";
				$y++;
			}
			$query_part2 .= " )\n";
		}
	//	else if ( in_array($thiscommand,$filesizecommands) )
	//	{	
	//		$thisarg = $indiv_arg[0];
	//		$thisarg = $thisarg * 1000000;
	//		$query_part2 .= "\nAND filesize = $thisarg";
	//	}
		else if ( in_array($thiscommand,$hascommands) )
		{	$y=0;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (in_array($thisarg, $attributes))
				{
					$query_part2 .= "\nAND $thisarg = 'y' ";
				}
				else if (in_array($thisarg, $allplanames) )
				{	$inp=$thisarg;
					ArrayWalkPlaToNum($inp);
					$thisarg=NumToPla($inp);
					$query_part2 .= "\nAND ( ( $thisarg = -8 ) OR ($thisarg > 0) )\n";
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand,$hasntcommands) )
		{	$y=0;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (in_array($thisarg, $attributes))
				{
					$query_part2 .= "\nAND $thisarg != 'y' ";
				}
				else if (in_array($thisarg, $allplanames) )
				{	$inp=$thisarg;
					ArrayWalkPlaToNum($inp);
					$thisarg=NumToPla($inp);
					$query_part2 .= "\nAND ( ( $thisarg = -9 ) OR ($thisarg = 0) )\n";
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand, $outputplaylistcommands ) )
		{	$outputplaylist=true;
		}
		else if ( in_array($thiscommand, $outputsearchcommands) )
		{	$outputsearch=true;
		}
		else if ( in_array($thiscommand, $alllabelcommands ) )
		{
			$outlist = array();
			$inlist = array();

			$num_of_in=0;
			$num_of_out=0;
			
			array_walk($indiv_args, ArrayWalkInOrNot);

			if (!empty($outlist) )
			{
				array_walk($outlist, ArrayWalkPlaToNum);
				$num_of_out=count($outlist);
				$regluedout=implode(", ", $outlist);

			}
			if (!empty($inlist) )
			{
				array_walk($inlist, ArrayWalkPlaToNum);
				$num_of_in=count($inlist);
				$regluedin=implode(", ", $inlist);
			}

			if ( in_array($thiscommand,$label2or3commands) )
			{
				if ($regluedin)
				{	$query_part2 .= "\nAND (vgSongDetails.label2 IN ($regluedin) OR vgSongDetails.label3 IN ($regluedin) )";
				}
				if ($regluedout)
				{	$query_part2 .= $query_part2 . "\nAND (vgSongDetails.label2 NOT IN ($regluedout) AND vgSongDetails.label3 NOT IN ($regluedout) )";
				}
			}
			else if ( in_array($thiscommand,$label1or2commands) )
			{
				if ($regluedin)
				{	$query_part2 .= "\nAND (vgSongDetails.label1 IN ($regluedin) OR vgSongDetails.label2 IN ($regluedin) )";
				}
				if ($regluedout)
				{	$query_part2 .= $query_part2 . "\nAND (vgSongDetails.label1 NOT IN ($regluedout) AND vgSongDetails.label2 NOT IN ($regluedout) )";
				}
			}
			else if ( in_array($thiscommand,$eachlabelandsublabelcommands) )
			{
				$y=0;
				while ($y<$num_of_in)
				{
					$thisarg=$inlist[$y];
					$thisarg=NumToPlanet($thisarg);
					$thisarg = "\"%" . $thisarg . "%\"";
					if ($y>0)
					{	$inquer .= "\nOR\n ";
					}
					$inquer .= "( vgSongDetails.sublabels LIKE $thisarg)";
					$y++;
				}

				$y=0;
				while ($y<$num_of_out)
				{	$thisarg=$outlist[$y];
					$thisarg=NumToPlanet($thisarg);

					$thisarg = "\"%" . $thisarg . "%\"";
					if ($y>0)
					{	$outquer .= "\nAND\n ";
					}
					$outquer .= "( vgSongDetails.sublabels NOT LIKE $thisarg)";
					$y++;
				}

				if ($num_of_in>=4)
				{
					$query_part2 .= "

AND 
(	
	(	vgSongDetails.label1 IN ($regluedin) 
		AND 
		vgSongDetails.label2 IN ($regluedin) 
		AND 
		vgSongDetails.label3 IN ($regluedin) 
		AND
		( $inquer
		)
	)
)";
		//echo "BWAHAHA!  $query_part2";

				}
				if ($num_of_in==1)
				{
					$query_part2 .= "

AND 
(	
	(	vgSongDetails.label1 IN ($regluedin) 
		OR 
		vgSongDetails.label2 IN ($regluedin) 
		OR 
		vgSongDetails.label3 IN ($regluedin) 
		OR
		( $inquer
		)
	)
)";
				}
				if ($num_of_in==2)
				{
					$query_part2 .= "

AND 
(
	(	vgSongDetails.label1 IN ($regluedin) 
		AND
		vgSongDetails.label2 IN ($regluedin)
	)
	OR 
	(	vgSongDetails.label1 IN ($regluedin) 
		AND
		vgSongDetails.label3 IN ($regluedin)
	)
	OR
	(	vgSongDetails.label1 IN ($regluedin) 
		AND
		(	$inquer
		)
	)
	OR
	(	vgSongDetails.label2 IN ($regluedin) 
		AND
		vgSongDetails.label3 IN ($regluedin)
	)
	OR
	(	vgSongDetails.label2 IN ($regluedin) 
		AND
		(	$inquer
		)
	)
	OR
	(	vgSongDetails.label3 IN ($regluedin) 
		AND
		(	$inquer
		)
	)
)";
				}
				if ($num_of_in==3)
				{
					$query_part2 .= "

AND 
(
	(	vgSongDetails.label1 IN ($regluedin) 
		AND 
		vgSongDetails.label2 IN ($regluedin) 
		AND 
		vgSongDetails.label3 IN ($regluedin) 
	)
	OR
	(	vgSongDetails.label1 IN ($regluedin) 
		AND 
		vgSongDetails.label2 IN ($regluedin) 
		AND 
		(	$inquer
		)
	)
	OR
	(	vgSongDetails.label1 IN ($regluedin) 
		AND 
		vgSongDetails.label3 IN ($regluedin) 
		AND 
		(	$inquer
		)
	)
	OR
	(	vgSongDetails.label2 IN ($regluedin) 
		AND 
		vgSongDetails.label3 IN ($regluedin) 
		AND 
		(	$inquer
		)
	)
)";
				}
				if ($num_of_out)
				{	$query_part2 .= "
AND 
(
	vgSongDetails.label1 NOT IN ($regluedout) 
	AND 
	vgSongDetails.label2 NOT IN ($regluedout) 
	AND 
	vgSongDetails.label3 NOT IN ($regluedout) 
	AND
	(	$outquer
	)
)";

				}

				unset($regluedin);
				unset($regluedout);
			}
			else if ( in_array($thiscommand,$eachlabelcommands) )
			{
				if ($num_of_in==3)
				{	if ($regluedin)
					{	$query_part2 .= "AND (vgSongDetails.label1 IN ($regluedin) AND vgSongDetails.label2 IN ($regluedin) AND vgSongDetails.label3 IN ($regluedin) )";
					}
				}
				else if ($num_of_in==2)
				{	if ($regluedin)
					{

$query_part2 .= "

AND
(
	(	vgSongDetails.label1 IN ($regluedin) 
		AND 
		(
			( vgSongDetails.label2 IN ($regluedin) )
			OR (vgSongDetails.label3 IN ($regluedin) )
		) 
	) 
	OR
	(	vgSongDetails.label2 IN ($regluedin) 
		AND 
		(
			( vgSongDetails.label1 IN ($regluedin) )
			OR (vgSongDetails.label3 IN ($regluedin) )
		) 
	)
	OR
	(	vgSongDetails.label3 IN ($regluedin) 
		AND 
		(
			( vgSongDetails.label2 IN ($regluedin) )
			OR (vgSongDetails.label1 IN ($regluedin) )
		) 
	)
)";
					}
				}
				else if ($num_of_in==1)
				{	if ($regluedin)
					{	$query_part2 .= "AND (vgSongDetails.label1 IN ($regluedin) OR vgSongDetails.label2 IN ($regluedin) OR vgSongDetails.label3 IN ($regluedin) )";
					}
				}

				if ($regluedout)
				{	$query_part2 .= $query_part2 . "AND (vgSongDetails.label1 NOT IN ($regluedout) AND vgSongDetails.label2 NOT IN ($regluedout) AND vgSongDetails.label3 NOT IN ($regluedout) )";
				}
				unset($regluedin);
				unset($regluedout);
			}

			else //if command is label1, label2, or label3
			{	$query_part = "\nAND vgSongDetails.label";

				if ( in_array($thiscommand,$label1commands) )
				{	$query_part .= "1"; 
				}
				elseif ( in_array($thiscommand,$label2commands) )
				{	$query_part .= "2";
				}
				elseif ( in_array($thiscommand,$label3commands) )
				{	$query_part .= "3";
				}

				if ($regluedin)
				{
					$query_part2 .= $query_part . " IN ($regluedin) ";
				}
				if ($regluedout)
				{	$query_part2 .= $query_part . " NOT IN ($regluedout) ";
				};

				unset($regluedin);
				unset($regluedout);
			}
		}
		elseif ( in_array($thiscommand,$roletablecommands) )
		{	$roletablequery=true;
		}
	}
		$x++;

	}

	if ($displayeditlinks)
	{	$getsongidornot=", vgSongDetails.song_id";
	}


	return $query_part2;

}


function ConstructLengthComparisonQuery($field, $comparison)
{	global $indiv_args;

	$thisarg=$indiv_args[0];
	$quer = "AND vgSongDetails.$field $comparison $thisarg";
	return $quer;
}

function ConstructTextSearchQuery($field, $comparison, $quotesornot, $forceor)
{	global $num_of_args, $indiv_args, $outlist, $inlist;

	$outlist = array();
	$inlist = array();

	array_walk($indiv_args, ArrayWalkInOrNot);

	$num_of_out=count($outlist);
	$num_of_in=count($inlist);

	if ( !empty($inlist) )

	{	$y=0;
		$quer .= "\nAND (";
		while ($y<$num_of_in)
		{	$thisarg=$inlist[$y];
			if ($comparison=="LIKE")
			{	$thisarg = "%" . $thisarg . "%";
			}
			if ($quotesornot=="SingleQuoted")
			{	$thisarg = "'" . $thisarg . "'";
			}
			else if ($quotesornot=="DoubleQuoted")
			{	$thisarg = "\"" . $thisarg . "\"";
			}
			if ($y>0)
			{	if ($comparison=="LIKE" && $forceor==false)
				{	$quer .= "\nAND";
				}
				else
				{	$quer .= "\nOR";
				}
			}
			$quer .= " vgSongDetails.$field $comparison $thisarg";
			$y++;
		}
		$quer .= ")";
	}

	if ( !empty($outlist) )
	{	$y=0;
		$quer .= "\nAND (";

		while ($y<$num_of_out)
		{	$thisarg=$outlist[$y];
			if ($comparison=="LIKE")
			{	$thisarg = "%" . $thisarg . "%";
			}
			if ($quotesornot=="SingleQuoted")
			{	$thisarg = "'" . $thisarg . "'";
			}
			else if ($quotesornot=="DoubleQuoted")
			{	$thisarg = "\"" . $thisarg . "\"";
			}
			if ($comparison=="=")
			{	$finalcompare="!=";
			}
			else if ($comparison=="LIKE")
			{	$finalcompare="NOT LIKE";
			}
			if ($y>0 && $forceor==false)
			{	$quer .= "\nAND";
			}
			else if ($y>0 && $forceor==true)
			{	$quer .= "\nOR";
			}

			$quer .= " vgSongDetails.$field $finalcompare $thisarg";
			$y++;
		}
		$quer .= ")";
	}

	return $quer;
};


function ArrayWalkInOrNot($inp)
{	global $outlist, $inlist;

	$test=substr($inp, 0, 1);

	if ($test=="!")
	{	$res=substr($inp,1);
		$res=trim($res);
		array_push($outlist,$res);
	}
	else
	{
		array_push($inlist,$inp);
	}
}


function EncloseInSomething(&$value, $key, $enclosure)
{
	$reverse_enclosure=strrev($enclosure);
	$value = $enclosure . $value . $reverse_enclosure;
}


function trim_value(&$value) 
{
    $value = trim($value);
}


function ArrayWalkPlaToNum(&$inp)
{	global $menames, $venames, $manames, $junames, $sanames, $urnames, $nenames, $plnames, $ernames;

	if ( is_numeric($inp) )
	{	if ($inp>10 || $inp<0)
		{	$inp=0;
		}
		else
		{	return $inp;
		}
	}
	else
	
	if ( in_array($inp, $menames) )
	{	$inp = 1;
	}
	elseif ( in_array($inp, $venames) )
	{	$inp = 2;
	}
	elseif ( in_array($inp, $manames) )
	{	$inp = 3;
	}
	elseif ( in_array($inp, $junames) )
	{	$inp = 4;
	}
	elseif ( in_array($inp, $sanames) )
	{	$inp = 5;
	}
	elseif ( in_array($inp, $urnames) )
	{	$inp = 6;
	}
	elseif ( in_array($inp, $nenames) )
	{	$inp = 7;
	}
	elseif ( in_array($inp, $plnames) )
	{	$inp = 8;
	}
	elseif ( in_array($inp, $ernames) )
	{	$inp = 9;
	}
}

?>